<template>
<div class="wrapper wrapper-content animated fadeIn">
    <div class="row">
        <div class="col-md-4">
            <div class="ibox float-e-margins">
                <div class="ibox-title">
                    <h5>Profile Detail</h5>

                    <div class="ibox-tools">
                        <a @click="get_details()">
                            <i class="fa fa-refresh"></i>
                        </a>
                    </div>
                </div>

                <div class="ibox-title" v-if="loading">
                    <spinner ></spinner>
                </div>

                <div class="ibox-content" v-else>
                    <h3><strong>{{ user.name }}</strong></h3>
                    <p>
                        <i class="fa fa-envelope"></i>
                        &nbsp;{{ user.email }}
                    </p>
                    <h5>
                        Status : 
                        <p class="label label-primary" v-if="user.is_active">
                            ACTIVE
                        </p>
                        <p class="label label-danger" v-else>
                            IN-ACTIVE
                        </p>
                    </h5>
                    <h5 v-if="new_password">
                        New Password: 
                        <strong>{{ new_password }}</strong>
                    </h5>

                    <div class="user-button">
                        <div class="row">
                            <div class="col-md-6">
                                <button @click="modal_show()"
                                        class="btn btn-info btn-sm btn-block">
                                    <i class="fa fa-edit"></i> 
                                    Edit Details
                                </button>
                            </div>
                            <div class="col-md-6" v-bind:disable="pause_reset">
                                <button @click="user_reset_password()"
                                        class="btn btn-success btn-sm btn-block">
                                    <i class="fa fa-key"></i> 
                                    Reset Password
                            </button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="col-md-8">
            <div class="ibox float-e-margins">
                <div class="ibox-title">
                    <h5>User Role</h5>
                </div>
                <div class="ibox-title" v-if="loading">
                    <spinner></spinner>
                </div>

                <div class="ibox-content" v-else>
                    <div class="dd">
                        <ol class="dd-list" v-for="(role, index) in user.roles" :key="index">
                            <li class="dd-item">
                                <div class="dd-handle">
                                    <strong><span>{{ romanize(index + 1) }}</span>. {{ role.group }}</strong>
                                </div>
                                <ol class="dd-list">
                                    <li class="dd-item" v-for="(role, index) in role.role" :key="index">
                                        <div class="dd-handle">
                                            <span class="pull-right">
                                                <button @click="user_role_add( role.role_id )"
                                                        class="btn btn-info btn-xs btn-block"
                                                        v-if="!role.has_role">
                                                    &nbsp;Add&nbsp;&nbsp;
                                                </button>

                                                <button @click="user_role_remove( role.role_id )"
                                                        class="btn btn-danger btn-xs btn-block"
                                                        v-else>
                                                    Remove
                                                </button>
                                            </span>
                                            {{ index + 1 }}.

                                            &nbsp; {{ role.name }}
                                        </div>
                                    </li>
                                </ol>
                            </li>
                        </ol>
                    </div>
                </div>
            </div>

        </div>
    </div>

    <user-modal v-on:save="user_update" v-bind:modal="modal"></user-modal>
</div>
</template>

<script>
import axios from 'axios'
import Modal from './Modal.vue'
import Spinner from '../other/Spinner.vue'

export default {
    data() {
        return {
            user: '',
            modal: { 
                pause_save: false,
                errors: '',
                data: {
                    name: '',
                    email: '',
                }
            },
            loading: true,
            pause_reset: false,
            new_password: false
        }
    },
    components: {
        'user-modal': Modal,
        'spinner': Spinner
    },
    methods: {
        get_details () {
            this.loading = true
            
            let id = this.$route.params.id
            if( !id ) {
                this.$router.push({ name: 'user' })
            }else{
                axios.get(`user/${id}`).then(response => {
                    this.user = response.data
                    this.loading = false
                })
            }
        },
        modal_show() {
            this.modal.errors = ''
            this.modal.data = {
                name: this.user.name,
                email: this.user.email,
                is_active: this.user.is_active,
            }
            $('#user_modal').modal('show');
        },
        user_update( data ){
            axios.put(`/user/${this.user.id}`,  data ).then(response => {
                if(response.data.errors) {
                    this.modal.errors = response.data.errors
                }else{
                    $('#user_modal').modal('hide')
                    toastr.success( response.data.msg, 'Updated!' )
                    this.get_details()
                }
            })
        },
        user_reset_password() {
            this.pause_reset = true
            axios.put(`user/${this.user.id}/passwordreset`).then(response => {
                this.new_password = response.data.new_password
                toastr.info( response.data.new_password , 'New Password!' )
                toastr.success( response.data.msg, 'Password Reset!' )
                this.pause_reset = false      
            })
        },
        user_role_add( id ) {
            this.pause_reset = true
            axios.post(`user/${this.user.id}/role`, { role_id : id } ).then(response => {
                toastr.success( response.data.msg, 'Added!' )
                this.get_details()
            }).catch(resp => {
                console.log( resp )
            })
            this.pause_reset = false
        },
        user_role_remove( id ) {
            axios.delete(`user/${this.user.id}/role?role_id=${id}`).then(response => {
                 toastr.error( response.data.msg, 'Deleted!' )
                this.get_details()
            }).catch(resp => {
                console.log( resp )
            })
        },
        romanize( number ) {
            return romanize( number )
        }
    },
    created() {
        this.get_details()
    }
}
</script>

<style scoped>
    .dd-handle strong span {
        font-family: 'Times New Roman', Times, serif;
    }
</style>

